<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * плагин для MaxSite CMS
 * abc-catalog
 */
 
// функция - добавка, получаемая в mso_get_val('page_other_pages_function_add_custom_sql', false);
// добавляем условие получения только похожих страниц
function sql_add_similar_posts_tags()
{
	global $page;
	
    // не страница
	if (!isset($page['page_id']) or !$page['page_id']) return array();
 
	$CI = & get_instance();

    // добавим в запрос id похожих страниц
    $field_of_numbers = 'similar_post_tags_id'; // метаполе, где находится список похожих страниц
	
	// на всякий случай проверка, хотя поле должно быть обязатеьно
    if ( isset($page['page_meta'][$field_of_numbers][0]) and $page['page_meta'][$field_of_numbers][0]) 
	{	
       $array_id = mso_explode($page['page_meta'][$field_of_numbers][0]);
       if ($array_id) $CI->db->where_in('page.page_id', $array_id);
	}
}



// получим массив id страниц, похожих на текущую страницу и добавим в метаполе
function similar_posts_tags_get_id($count='')
{
$field_of_numbers = 'similar_post_tags_id'; // метаполе, где находится список похожих страниц

	
 global $page;
 if (!isset($page['page_id']) or !$page['page_id']) return;

 if (!$count) $count = mso_get_option('page_other_pages_limit', 'templates', 7);

 $cache_key = 'similar_posts_tags_get_id_' . $page['page_id'];
 
 $out = mso_get_cache($cache_key);
 
 if ($out) 
 {
   $page['page_meta'][$field_of_numbers][0] = $out;
   return;
 }

$options = mso_get_option('similar_posts_tags', 'plugins', array() );
if ( !isset($options['k_tag']) ) $options['k_tag'] = '1';
if ( !isset($options['k_cat']) ) $options['k_cat'] = '1';

$k_tag = (int) $options['k_tag'];
$k_cat = (int) $options['k_cat'];

 $bl_pages = array();
 
 // получим все страницы
 $par = array( 
   'no_limit' => true, // нам нужны все записи
   'type' => false, // любой тип страниц
   'custom_type' => 'home', // запрос как в home
   'work_cut'=>false,
   'content'=>false
  	); 

  $all_pages = mso_get_pages($par, $pagination); // получим все - второй параметр нужен для сформированной пагинации
 
 $bl_pages = array();
	
  if ($all_pages) // есть страницы
  { 	
    foreach ($all_pages as $cur_page) // сравниваем все страницы с текущей
    {
	    if ($cur_page['page_id'] == $page['page_id']) continue;
	    // похожесть страниц - это сколько у них одинаковых меток и категорий
	    $tag_similarity = count(array_intersect($cur_page['page_tags'] , $page['page_tags'])); 
	    $cat_similarity = count(array_intersect($cur_page['page_categories'] , $page['page_categories'])); 
		$similarity = $tag_similarity*$k_tag + $cat_similarity*$k_cat;
		if ($similarity) // если похожесть больше 0, тоесть есть общие метки и категории
		{
   		    $cur_page['similarity'] = $similarity;
	        $bl_pages[] = $cur_page; 
		} 
	}	
  } 
  
  // массив похожих страниц будет отортирован по убыванию похожести
  usort($bl_pages, "_cmp_similarity"); 

  // оставим заданное число номеров 
  $out=''; $i=0;
  if ( isset($page['page_meta'][$field_of_numbers][0]) and $page['page_meta'][$field_of_numbers][0]) 
  {	  
	$prior_id_array = mso_explode($page['page_meta'][$field_of_numbers][0]);
	$count = $count - count($prior_id_array);
  }		  

  foreach ($bl_pages as $cur_page)
  {
	$out .= $cur_page['page_id'] . ', ';  
    $i++; if ($i == $count) break;
  }	  

  // если есть что-то уже указано в метаполе номеров
  if ( isset($page['page_meta'][$field_of_numbers][0]) and $page['page_meta'][$field_of_numbers][0])  
  {
	// если список страниц существует, то берем их в начале
    $page['page_meta'][$options['field_of_numbers']][0] = $page['page_meta'][$field_of_numbers][0] . ', ' . $out;
  }
  else $page['page_meta'][$field_of_numbers][0] = $out;
  mso_add_cache($cache_key, $out);
  
  return;
}  

// вспомогательная функция сортировки
function _cmp_similarity ($a, $b)
{
    if ($a['similarity'] == $b['similarity']) return 0;
    return ($a['similarity'] > $b['similarity']) ? -1 : 1;
}
  
?>